<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-item label="唯一序号" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['queueId']" placeholder="请输入唯一序号"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="交易时间" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-date placeholder="请选择交易时间" v-decorator="['trxDate']" :trigger-change="true" style="width: 100%"/>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="操作人编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['userCode']" placeholder="请输入操作人编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="组织代码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['orgId']" placeholder="请输入组织代码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="仓库编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['storeCode']" placeholder="请输入仓库编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="物料编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['mtrlCode']" placeholder="请输入物料编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="数量" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['quantity']" placeholder="请输入数量"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="目的组织代码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['toOrgId']" placeholder="请输入目的组织代码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="目的仓库编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['toStoreCode']" placeholder="请输入目的仓库编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="调拨单编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['allotCode']" placeholder="请输入调拨单编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="行号" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['seq']" placeholder="请输入行号"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="备注" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['remark']" placeholder="请输入备注"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="fid" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['fid']" placeholder="请输入fid"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="单据编码" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['fbillNo']" placeholder="请输入单据编码"></a-input>
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item label="单据体内码-分录" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <a-input v-decorator="['fentryId']" placeholder="请输入单据体内码-分录"></a-input>
            </a-form-item>
          </a-col>
          <a-col v-if="showFlowSubmitButton" :span="24" style="text-align: center">
            <a-button @click="submitForm">提 交</a-button>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
  </a-spin>
</template>

<script>

  import { httpAction, getAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import { validateDuplicateValue } from '@/utils/util'
  import JFormContainer from '@/components/jeecg/JFormContainer'
  import JDate from '@/components/jeecg/JDate'  

  export default {
    name: 'ImsNondefectiveFlittingForm',
    components: {
      JFormContainer,
      JDate,
    },
    props: {
      //流程表单data
      formData: {
        type: Object,
        default: ()=>{},
        required: false
      },
      //表单模式：true流程表单 false普通表单
      formBpm: {
        type: Boolean,
        default: false,
        required: false
      },
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        form: this.$form.createForm(this),
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
        },
        url: {
          add: "/imsNondefectiveFlitting/add",
          edit: "/imsNondefectiveFlitting/edit",
          queryById: "/imsNondefectiveFlitting/queryById"
        }
      }
    },
    computed: {
      formDisabled(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return false
          }
          return true
        }
        return this.disabled
      },
      showFlowSubmitButton(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return true
          }
        }
        return false
      }
    },
    created () {
      //如果是流程中表单，则需要加载流程表单data
      this.showFlowData();
    },
    methods: {
      add () {
        this.edit({});
      },
      edit (record) {
        this.form.resetFields();
        this.model = Object.assign({}, record);
        this.visible = true;
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'queueId','trxDate','userCode','orgId','storeCode','mtrlCode','quantity','toOrgId','toStoreCode','allotCode','seq','remark','fid','fbillNo','fentryId'))
        })
      },
      //渲染流程表单数据
      showFlowData(){
        if(this.formBpm === true){
          let params = {id:this.formData.dataId};
          getAction(this.url.queryById,params).then((res)=>{
            if(res.success){
              this.edit (res.result);
            }
          });
        }
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }
         
        })
      },
      popupCallback(row){
        this.form.setFieldsValue(pick(row,'queueId','trxDate','userCode','orgId','storeCode','mtrlCode','quantity','toOrgId','toStoreCode','allotCode','seq','remark','fid','fbillNo','fentryId'))
      },
    }
  }
</script>